#!/usr/bin/env python
#Script by James Huntsman
#V1.2
#31/07/2009

import lx
import subprocess

tempPath = lx.eval1("query platformservice path.path ? temp")
filename = tempPath + "\\uvlayout.obj"
filenameOut = tempPath + "\\uvlayout.out"
filenameCmd = tempPath + "\\uvlayout.cmd"

uvlayout = ""

# Enter the location of UVLayout below - uncomment one of the selections by removing the #
# or add a new location without a #

# Windows XP 32
#uvlayout = "C:\\Program Files\\headus UVLayout v2 Professional\\uvlayout.exe"

# Windows 7 64
#uvlayout = "C:\\Program Files (x86)\\headus UVLayout v2 Professional\\uvlayout.exe"

psubd = 1
pedit = 0
pweld = 0
pclean = 0
pdetach = 0
padd = 0
pdebug = 0

pexport = 1

def StartUVLayout():
    uvlayoutpath = []

    uvparameters = "-plugin"
    
    if (psubd == 1):
        uvparameters += ",SUBD"
    else:
        uvparameters += ",Poly"

    if (pedit == 1):
        uvparameters += ",Edit"
    else:
        uvparameters += ",New"

    if (pweld == 1):
        uvparameters += ",Weld"
    
    if (pclean == 1):
        uvparameters += ",Clean"
    
    if (pdetach == 1):
        uvparameters += ",Detach"

    uvlayoutpath.append(uvlayout)
    uvlayoutpath.append(uvparameters)
    uvlayoutpath.append(filename)
    
    subprocess.Popen(uvlayoutpath)
    
def ExportToUVLayout():
    cmdfile = open(filenameCmd, 'w') 
    layers = lx.evalN("query layerservice layers ? selected");
    objfile = open(filename, 'w')
    
    for layer in layers:
        lx.eval("select.layer %s" % layer)
        layerIndex = lx.eval1("query layerservice layer.index ? %s" % layer)
        
        verts = lx.evalN("query layerservice verts ? all")
        polys = lx.evalN("query layerservice polys ? all")
        mapCount = lx.eval1("query layerservice vmap.N ? all")
        
        defaultKey = "-1"
        uvMapCount = 0
        selectedCount = 0
        if (pedit == 1):
            for m in range(mapCount):
                mapType = lx.eval1("query layerservice vmap.type ? %s" % m)
                if (mapType == "texture"):
                    uvMapCount += 1
                    mapName = lx.eval1("query layerservice vmap.name ? %s" % m)
                    mapSelected = lx.eval1("query layerservice vmap.selected ? %s" %m)
                    
                    if (mapSelected == int(1)):
                        selectedCount += 1
                    
        
        totalCount = len(verts) * 2
        if (uvMapCount == 0):
            totalCount += len(polys)
        elif (uvMapCount == 1):
            uvs = lx.evalN("query layerservice uvs ? all")
            totalCount += len(polys) + len(uvs)
        else:
            if (selectedCount == 1):
                uvs = lx.evalN("query layerservice uvs ? all")
                totalCount += len(polys) + len(uvs)
            
        mon.init(totalCount)
    
        vertCount = 0
        normCount = 0
        texCount = 0
        polyIndex = 0 #zero based
        
        vertices = []
        normals = []
        texCoords = []
        fsverts = {}
        fsnorms = {}
        fsUVs ={}
        
        for vert in verts:
            mon.step(1)
            vert_position = lx.evalN("query layerservice vert.pos ? %s" % vert)
            pos0 = vert_position[0]
            pos1 = vert_position[1]
            pos2 = vert_position[2]
            
            vertString = "%s %s %s"%(pos0, pos1, pos2)
            vertices.append(pos0)
            vertices.append(pos1)
            vertices.append(pos2)
            
            found = 0
            
            if (len(fsverts) > 0):
                key = fsverts.get(vertString, defaultKey)
                if (int(key) >= 0): 
                    vertices.append(int(key)) # add to the end as column 4
                    found = 1
          
            if (found == 0):
                objfile.write('v %s'%vertString)
                objfile.write('\n')
                  
                fsverts[vertString] = vertCount
                vertices.append(vertCount) # add to the end as column 4
                vertCount += 1
                
                
        for vert in verts:
            mon.step(1)
            normal_position = lx.evalN("query layerservice vert.normal ? %s" % vert)
            pos0 = normal_position[0]
            pos1 = normal_position[1]
            pos2 = normal_position[2]
               
            normString = "%s %s %s"%(pos0, pos1, pos2)
            normals.append(pos0)
            normals.append(pos1)
            normals.append(pos2)
              
            found = 0;
            
            if (len(fsnorms) > 0):
                key = fsnorms.get(normString, defaultKey)
                if (int(key) >= 0): 
                    normals.append(int(key)) # add to the end as column 4
                    found = 1            
            
            if (found == 0):
                objfile.write("vn %s"%normString)
                objfile.write("\n")
                
                fsnorms[normString] = normCount
                normals.append(normCount)
                normCount += 1

        if (pedit == 1):
        
            for m in range(mapCount):
                mapType = lx.eval1("query layerservice vmap.type ? %s" % m)
        
                if (mapType == "texture"):
                    mapName = lx.eval1("query layerservice vmap.name ? %s" % m)
                    mapSelected = lx.eval1("query layerservice vmap.selected ? %s" %m)
                    
                    if (uvMapCount == 1 or (uvMapCount > 1 and mapSelected == int(1))):
                        uvs = lx.evalN("query layerservice uvs ? all")
                        
                        for uv in uvs:
                            mon.step(1)
                            pos = lx.evalN("query layerservice uv.pos ? %s" %uv)
                            pos0 = pos[0]
                            pos1 = pos[1]
                            
                            texString = "%s %s"%(pos0, pos1)
                            texCoords.append(pos0)
                            texCoords.append(pos1)
                            
                            found = 0
                            
                            if (len(fsUVs) > 0):
                                key = fsUVs.get(texString, defaultKey)
                                if (int(key) >= 0): 
                                    texCoords.append(int(key)) # add to the end as column 4
                                    found = 1      
                                                            
                            if (found == 0):
            
                                objfile.write("vt %s"%texString)
                                objfile.write("\n")
                                  
                                fsUVs[texString] = texCount
                                texCoords.append(texCount) # add to the end as column 3
                                texCount += 1
                    
                        for poly in polys:
                        
                            mon.step(1)
                            poly_verts = lx.evalN("query layerservice poly.vertList ? %s" % poly)
                            numVerts = lx.eval1("query layerservice poly.numVerts ? %s" % poly)
                            polyVmaps = lx.evalN("query layerservice poly.vmapValue ? %s" % poly)
            
                            objfile.write("f")
                        
                            for i in range (numVerts):
                                
                                objfile.write(" ")
                            
                                index = vertices[poly_verts[i] * 4 + 3]
                                objfile.write(str(index + 1))
                                objfile.write("/")
                            
                                uv0 = polyVmaps[i * 2 + 0]
                                uv1 = polyVmaps[i * 2 + 1]
                                uvString = "%s %s"%(uv0, uv1)
                         
                                if (len(fsUVs) > 0):
                                    key = fsUVs.get(uvString, defaultKey)
                                    if (int(key) >= 0): 
                                        objfile.write(str(key + 1))
                         
                                objfile.write("/")
                            
                                index = normals[poly_verts[i] * 4 + 3]
                                objfile.write(str(index + 1))
                            
                            objfile.write("\n")
                            polyIndex += 1
                
        if (int(texCount) == 0 and int(uvMapCount) == 0):
            for poly in polys:
                mon.step(1)    
                poly_verts = lx.evalN("query layerservice poly.vertList ? %s" % poly)
                numVerts = lx.eval1("query layerservice poly.numVerts ? %s" % poly)
                
                objfile.write("f")
                
                for i in range (numVerts):
                        
                    objfile.write(" ")
                    index = vertices[poly_verts[i] * 4 + 3]
                    objfile.write(str(index + 1))
                    objfile.write("//")
                    index = vertices[poly_verts[i] * 4 + 3]
                    objfile.write(str(index + 1))
                    
                objfile.write("\n")
                polyIndex += 1
        break;
    
    objfile.close
    
    if (polyIndex > 0):
        StartUVLayout()
    
def ImportFromUVLayout():
    layers = lx.evalN("query layerservice layers ? selected")
    
    outfile = []
    
    try:
        
        outfile = open(filenameOut, 'r')
        
    except:
        
        lx.eval('dialog.setup info')
        lx.eval('dialog.title {UVLayout Info}')
        lx.eval('dialog.msg {Press the Send button in UVLayout before Importing into Modo}')
        lx.eval('dialog.open')
    
    texCoords = []
    polyUVs = []
    vertices = []
    
    texcoordvertices = []
    discopolygons = {}
    discovertices = []
    
    polygonindex = 0
    
    for line in outfile:
        data = line.split()
        
        if (data[0] == 'v'):
            vertexstring = "%s %s %s"%(data[1], data[2], data[3])
            vertices.append(vertexstring)
            texcoordvertices.append(0)
        elif (data[0] == 'vt'):
            texcoordstring = "%s %s"%(data[1], data[2])
            texCoords.append(texcoordstring)  
        elif (data[0] == 'f'):
            vertexCount = len(data)
    
            polyString = ""
            for i in range(1, vertexCount - 1):
                polyString += data[i]
                polyString += " "
                faceData = data[i].split('/')
                if (faceData[1] != ''):
                    v = faceData[0]
                    vt = faceData[1]
    
                    if (int(texcoordvertices[int(v) - 1]) == int(0)):
                        texcoordvertices[int(v) - 1] = vt
                    else:
                        if (int(texcoordvertices[int(v) - 1]) != int(vt)):
                            for j in range (1, vertexCount - 1):
                                discoData = data[j].split('/')
                                discovertices.append(discoData[0])
                
            polyString += data[vertexCount - 1]
            polyUVs.append(polyString)
            polygonindex += 1
                
    outfile.close
    
    if (len(texCoords) > 0):
        defaultKey = "-1"
        polygonindex = 0
        
        polyUVCount = len(polyUVs) * 2
        mon.init(polyUVCount)
        for polyUV in polyUVs:
            data = polyUV.split(' ')
            mon.step(1)
            
            found = 0
            for i in range (len(data)):
                faceData = data[i].split('/')
                v = faceData[0]
                    
                for dv in discovertices:
                    if (int(v) == int(dv)):
                        discopolygons[polygonindex] = 1
                        found = 1
                        break
                        
                if (found == 1):
                    break
    
            polygonindex += 1                
        
        for layer in layers:
            lx.eval("select.layer %s" % layer)        
            layerIndex = lx.eval1("query layerservice layer.index ? %s" % layer)
            mapCount = lx.eval1("query layerservice vmap.N ? all")
    
            vmaps = []
            for m in range(mapCount):
                mapType = lx.eval1("query layerservice vmap.type ? %s" % m)
                mapName = lx.eval1("query layerservice vmap.name ? %s" % m)
        
                if (mapType == "texture"):
                    vmaps.append(mapName)
         
            if (padd == 0):
                for vmap in vmaps:
                    lx.eval("!!select.vertexMap [%s] [txuv] [replace]" %vmap)
                    lx.eval("!!vertMap.delete type:txuv")
    
            newMapName = "TextureUV_"
            
            if (padd == 1):
                newIndex = 0
                for vmap in vmaps:
                    if (len(vmap) > 9):
                        if (vmap[0:10] == newMapName):
                            if (len(vmap) > 10):
                                vmapIndex = int(vmap[10 - (len(vmap)):])
                                if (int(vmapIndex) > int(newIndex)):
                                    newIndex = vmapIndex
                newMapName += str(newIndex + 1)
            else:
                newMapName += str(0)
            
            lx.eval("vertMap.new %s txuv"%(newMapName))
            mapCount = lx.eval1("query layerservice vmap.N ? all")
            
            for m in range(mapCount):
                mapType = lx.eval1("query layerservice vmap.type ? %s" % m)
                mapName = lx.eval1("query layerservice vmap.name ? %s" % m)
        
                if (mapType == "texture" and mapName == newMapName):
                    for p in range(len(polyUVs)):
                        polyUV = polyUVs[int(p)]
                        data = polyUV.split(' ')
                        mon.step(1)
    
                        poly_verts = lx.evalN("query layerservice poly.vertList ? %s" % p)
                        numVerts = lx.eval1("query layerservice poly.numVerts ? %s" % p)
    
                        foundDisco = 0
                            
                        if (len(discopolygons) > 0):
                            key = discopolygons.get(p, defaultKey)
                            if (int(key) == 1): 
                                foundDisco = 1
                       
                        for i in range (numVerts):
                            index = poly_verts[i]
                            faceData = data[i].split('/')
    
                            if (faceData[1] != ''):
                                mVertex = int(faceData[0])
                                pVertex = int(faceData[1])
                                
                                vtdata = texCoords[(pVertex - 1)]
                                vt = vtdata.split()
        
                                uv0 = float(vt[0])
                                uv1 = float(vt[1])
                                
                                if (foundDisco == 0):
                                    lx.eval('vertMap.setVertex %s %s 0 %s %s'%(mapName, mapType, mVertex - 1, uv0))
                                    lx.eval('vertMap.setVertex %s %s 1 %s %s'%(mapName, mapType, mVertex - 1, uv1))
                                else:
                                    lx.eval("select.element %s polygon set %s" %(layer, p))
                                    lx.eval("select.element %s vertex set %s" %(layer, mVertex - 1))
                                    lx.eval("vertMap.setPValue {%s %s}" %(uv0, uv1))                       

def SendCommand(command):
    cmdfile = open(filenameCmd, 'a')    
    cmdfile.write(command)
    cmdfile.write('\n')
    cmdfile.close
    
def CheckForUVLayout():
    if (len(uvlayout) > 0):
        return 1
    return 0

if (CheckForUVLayout() == 0):
    
    lx.eval('dialog.setup info')
    lx.eval('dialog.title {UVLayout Info}')
    lx.eval('dialog.msg {UVLayout path not found}')
    lx.eval('dialog.open')
    
else:
    
    mon = lx.Monitor()
    
    for arg in lx.args():
       
        if (arg == 'Export'):
            pexport = 1
        elif (arg == 'Import'):
            pexport = 0
        elif (arg == 'Edit'):
            pedit = 1
        elif (arg == 'New'):
            pedit = 0
        elif (arg == 'SUBD'):
            psubd = 1
        elif (arg == 'Poly'):
            psubd = 0
        elif (arg == 'Clean'):
            pclean = 1
        elif (arg == 'Weld'):
            pweld = 1
        elif (arg == 'Detach'):
            pdetach = 1
        elif (arg == 'Vmap'):
            padd = 1
        elif (arg == 'ExportToUVLayout'):
            pexport == 1
            type = lx.evalN("user.value UVLType ?")
            if (type[0] == 'SUBD'):
                psubd = 1
            else:
                psubd = 0
                
            uvs = lx.evalN("user.value UVLUVs ?")
            if (uvs[0] == 'Edit'):
                pedit = 1
            else:
                pedit = 0
    
            pclean = lx.eval1("user.value Clean ?")
            pweld = lx.eval1("user.value Weld ?")
            pdetach = lx.eval1("user.value Detach ?")
            break
        elif (arg == 'ImportFromUVLayout'):
            pexport = 0
            padd = lx.eval1("user.value Vmap ?")
            break
        elif (arg == 'Close'):
            pexport = 2
            SendCommand("Exit")
    
            
    if (pexport == 0):
        ImportFromUVLayout()
    elif (pexport == 1):
        ExportToUVLayout()



